// FlatDir.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include "basic_dir_info.h"

typedef std::basic_string<_TCHAR> tstring;
typedef basic_dir_info<_TCHAR> dir_info;

#ifdef _UNICODE
#define _tcout std::wcout
#else
#define _tcout std::cout
#endif

int _tmain(int argc, _TCHAR* argv[])
{
	_tsetlocale( LC_ALL, _T("") );

	// Ȃꍇ̓bZ[W\ďI
	if( argc <= 1 ) {
		_ftprintf( stdout,
			_T("[usage] %s fBNg\nw肵fBNgzɂSẴTufBNg")
			_T("̃fBNg̒ڂ̃TufBNgɈړ܂B"), argv[ 0 ] );
		return 1;
	}

	// Ƃ
	tstring initDir = argv[ 1 ];

	// \܂/폜
	int lastchr = 0;
	for( tstring::iterator ite = initDir.begin();
		ite != initDir.end();
		++ite )
	{
		lastchr = (unsigned int) *ite;
		if( _istleadbyte( lastchr ) ) {
			++ite;
			if( ite == initDir.end() ) {
				break;
			}
		}
	}
	if( lastchr == '\\' || lastchr == '/' ) {
		initDir.erase( initDir.end() - 1 );
	}

	// ꂽfBNg
	std::list<dir_info> dir_info_list;

	// fBNg̑
	std::queue<dir_info> checkdirs;
	checkdirs.push( dir_info( -1, _T(""), initDir ) );

	while( ! checkdirs.empty() ) {
		const dir_info dirInfo = checkdirs.front();
		checkdirs.pop();

		const tstring searchname = dirInfo.get_fullpath() + _T("\\*.*");

		_tfinddata64_t finddata;
		intptr_t hFind = _tfindfirst64( searchname.c_str(), &finddata );
		if( hFind != -1 ) {
			do {
				if( finddata.attrib & _A_SUBDIR ) {
					const tstring subdirname( finddata.name );
					if( subdirname != _T("..") && subdirname != _T(".") ) {
						const dir_info nextDir( dirInfo.get_level() + 1, dirInfo.get_fullpath(), subdirname );
						dir_info_list.push_back( nextDir );
						checkdirs.push( nextDir );
					}
				}
			} while( ! _tfindnext64( hFind, &finddata ) );
			_findclose( hFind );
		}
	}

	// ꂽfBNg[ɕёւ
	dir_info_list.sort();

	// ŉw̃fBNg̏Փˉp̃}bv
	// ̃x0fBNglɃZbg
	std::map<tstring,int> dupdirmap;
	for( std::list<dir_info>::iterator ite = dir_info_list.begin();
		ite != dir_info_list.end();
		++ite )
	{
		const dir_info& dirInfo = *ite;
		if( dirInfo.get_level() == 0 ) {
			tstring destName( dirInfo.get_name() );
			dupdirmap.insert( std::pair<tstring,int>( destName, 1 ) );
		}
	}

	// [ɃfBNgtbg
	for( std::list<dir_info>::iterator ite = dir_info_list.begin();
		ite != dir_info_list.end();
		++ite )
	{
		const dir_info& dirInfo = *ite;
		if( dirInfo.get_level() > 0 ) {
			tstring destName( dirInfo.get_name() );
			std::map<tstring,int>::iterator pos = dupdirmap.find( destName );
			if( pos != dupdirmap.end() ) {
				int& count = pos->second;
				count++;
				_TCHAR buf[ 64 ];
				_stprintf( buf, _T("-%d"), count );
				destName += buf;
			}
			else {
				dupdirmap.insert( std::pair<tstring,int>( destName, 1 ) );
			}

			const tstring destPath = initDir + _T("\\") + destName;

			_tcout << dirInfo.get_level() << _T(":")
				<< dirInfo.get_fullpath() << _T(" -> ") 
				<< destPath << " ";

			const int result = _trename( dirInfo.get_fullpath().c_str(), destPath.c_str() );

			_tcout << ( ( result == 0 ) ? _T( "ok" ) : _T("failed") ) << std::endl;
		}
	}

	return 0;
}

